#include <amxmodx>
#include <amxmisc>
#include <engine>

#include <diablo_nowe.inc>

#define PLUGIN	"New Plugin"
#define AUTHOR	"DarkGL"
#define VERSION	"1.0"

new bool:bHas[ 33 ];

new SWORD_VIEW[]         = "models/diablomod/v_knife.mdl" 
new SWORD_PLAYER[]       = "models/diablomod/p_knife.mdl" 

public plugin_init()
{
	register_plugin(PLUGIN, VERSION, AUTHOR)
	
	diablo_register_item( "Miecz" , 250 );
}

public plugin_precache(){
	precache_model( SWORD_VIEW );
	precache_model( SWORD_PLAYER );
}

public diablo_item_give( id , szRet[] , iLen ){
	formatex( szRet , iLen , "zadajesz wieksze obrazenia nozem" )
	
	bHas[ id ]	=	true;
}

public diablo_item_reset( id ){
	bHas[ id ]	=	false;
}


public diablo_item_info( id , szMessage[] , iLen , bool:bList ){
	if( bList ){
		formatex( szMessage , iLen , "zadajesz wieksze obrazenia nozem")
	}
	else{
		formatex( szMessage , iLen , "zadajesz wieksze obrazenia nozem" )
	}
}

public diablo_damage_item_do(iVictim,iAttacker,&Float:fDamage,damageBits){
	if( get_user_weapon( iAttacker ) == CSW_KNIFE && bHas[ iAttacker ] && random_num( 1 , 10 ) == 1 ){
		diablo_kill( iVictim , iAttacker , diabloDamageKnife );
	}
}

public diablo_weapon_deploy(id,wpnID,weaponEnt){
	if( bHas[ id ] && wpnID == CSW_KNIFE ){
		entity_set_string(id, EV_SZ_viewmodel, SWORD_VIEW)  
		entity_set_string(id, EV_SZ_weaponmodel, SWORD_PLAYER)  
	}
}

public diablo_copy_item( iFrom , iTo ){
	bHas[ iTo ]	=	true;
	bHas[ iFrom ]	=	false;
}