#include <amxmodx>
#include <amxmisc>

#include <diablo_nowe.inc>

#define PLUGIN	"New Plugin"
#define AUTHOR	"DarkGL"
#define VERSION	"1.0"

new iNiewidka[ 33 ];

public plugin_init()
{
	register_plugin(PLUGIN, VERSION, AUTHOR)
	
	diablo_register_item( "Zbroja Niewidka" , 250 );
}

public diablo_item_give( id , szRet[] , iLen ){
	formatex( szRet , iLen , "+%i premii niewidocznosci" , 255 - iNiewidka[ id ] )
	
	diablo_set_user_render( id , kRenderFxNone, 0, 0, 0, kRenderTransAlpha, iNiewidka[ id ] , 0.0)
}

public diablo_item_reset( id ){
	iNiewidka[ id ]	=	0;
}

public diablo_item_set_data( id ){
	iNiewidka[ id ]	=	random_num(70,100);
	
	diablo_render_cancel( id );
}

public diablo_copy_item( iFrom , iTo ){
	iNiewidka[ iTo ]	=	iNiewidka[ iFrom ];
	iNiewidka[ iFrom ]	=	0;
	
	diablo_render_cancel( iFrom );
	diablo_set_user_render( iTo , kRenderFxNone, 0, 0, 0, kRenderTransAlpha, iNiewidka[ iTo ] , 0.0)
}


public diablo_item_info( id , szMessage[] , iLen , bool:bList ){
	if( bList ){
		formatex( szMessage , iLen , "Twoja widocznosc jest zredukowana z 255")
	}
	else{
		formatex( szMessage , iLen , "Twoja widocznosc jest zredukowana z 255 do %d" , iNiewidka[ id ] )
	}
}

public diablo_item_player_spawned( id ){
	diablo_set_user_render( id , kRenderFxNone, 0, 0, 0, kRenderTransAlpha, iNiewidka[ id ] , 0.0)
}

public diablo_upgrade_item( id ){
	iNiewidka[ id ]	-=	random_num(-10,10)
}
