#include <amxmodx>
#include <amxmisc>

#include <diablo_nowe.inc>

#define PLUGIN	"New Plugin"
#define AUTHOR	"DarkGL"
#define VERSION	"1.0"

new iDmg[ 33 ];

public plugin_init()
{
	register_plugin(PLUGIN, VERSION, AUTHOR)
	
	diablo_register_item( "Zelazna Zbroja" , 250 );
}

public diablo_item_give( id , szRet[] , iLen ){
	formatex( szRet , iLen , "+%i Obniza uszkodzenia zadawane graczowi" , iDmg[ id ] )
}

public diablo_item_reset( id ){
	iDmg[ id ]	=	0;
}

public diablo_item_set_data( id ){
	iDmg[ id ]	=	random_num( 3 , 6 );
}

public diablo_item_info( id , szMessage[] , iLen , bool:bList ){
	if( bList ){
		formatex( szMessage , iLen , "Obrazenia sa zredukowane o x hitpoints")
	}
	else{
		formatex( szMessage , iLen , "Obrazenia sa zredukowane o %i hitpoints" , iDmg[ id ] )
	}
}

public diablo_damage_item_taken(iVictim,iAttacker,&Float:fDamage,damageBits){
	fDamage -= float( iDmg[ iVictim ] );
}

public diablo_upgrade_item( id ){
	iDmg[ id ] += random_num( 0 , 2 );
}

public diablo_copy_item( iFrom , iTo ){
	iDmg[ iTo ]	=	iDmg[ iFrom ];
	iDmg[ iFrom ]	=	0;
}