#include <amxmodx>
#include <amxmisc>
#include <hamsandwich>

#include <diablo_nowe.inc>

#define PLUGIN	"New Plugin"
#define AUTHOR	"DarkGL"
#define VERSION	"1.0"

new iRespawn[ 33 ];

public plugin_init()
{
	register_plugin(PLUGIN, VERSION, AUTHOR)
	
	diablo_register_item( "Amulet Smierci" , 250 );
}

public diablo_item_give( id , szRet[] , iLen ){
	formatex( szRet , iLen , "1/%i szans do ponownego odrodzenia sie po smierci" , iRespawn[ id ] )
}

public diablo_item_reset( id ){
	iRespawn[ id ]	=	0;
}

public diablo_item_set_data( id ){
	iRespawn[ id ]	=	random_num( 1 , 3 );
}

public diablo_item_info( id , szMessage[] , iLen , bool:bList ){
	if( bList ){
		formatex( szMessage , iLen , "Masz 1/x szanse do odrodzenia sie po zgonie")
	}
	else{
		formatex( szMessage , iLen , "Masz 1/%i szanse do odrodzenia sie po zgonie" , iRespawn[ id ] )
	}
}

public diablo_death( iKiller , killerClass , iVictim , victimClass ){
	if( iRespawn[ iVictim ] > 0 && random_num( 1 , iRespawn[ iVictim] ) == 1 ){
		ExecuteHamB( Ham_CS_RoundRespawn , iVictim )
	}
}

public diablo_upgrade_item( id ){
	iRespawn[ id ]	-=	random_num( -1 , 1 )
}

public diablo_copy_item( iFrom , iTo ){
	iRespawn[ iTo ]	=	iRespawn[ iFrom ];
	iRespawn[ iFrom ]	=	0;
}