#include <amxmodx>
#include <amxmisc>
#include <fun>
#include <csx>

#include <diablo_nowe.inc>

#define PLUGIN	"New Plugin"
#define AUTHOR	"DarkGL"
#define VERSION	"1.0"

new iGrenade[ 33 ] , bool:bItem[ 33 ];

public plugin_init()
{
	register_plugin(PLUGIN, VERSION, AUTHOR)
	
	diablo_register_item( "Plomienne Rekawice" , 250 );
}

public diablo_item_give( id , szRet[] , iLen ){
	formatex( szRet , iLen , "1/%i zabicia z HE oraz co 15 sekund w twojej dloni pojawia sie granacik" , iGrenade[ id ] )
	
	bItem[ id ]	=	true;
}

public diablo_item_reset( id ){
	iGrenade[ id ]	=	0;
	
	bItem[ id ]	=	false;
	
	remove_task( id )
}

public diablo_item_set_data( id ){
	iGrenade[ id ]	=	random_num( 1 , 4 );
}

public diablo_item_player_spawned( id ){
	remove_task( id );
}

public diablo_item_info( id , szMessage[] , iLen , bool:bList ){
	if( bList ){
		formatex( szMessage , iLen , "1/x zabicia z HE oraz co 15 sekund w twojej dloni pojawia sie granacik")
	}
	else{
		formatex( szMessage , iLen , "1/%i zabicia z HE oraz co 15 sekund w twojej dloni pojawia sie granacik" , iGrenade[ id ] )
	}
}

public diablo_damage_item_do(iVictim,iAttacker,&Float:fDamage,damageBits){
	if( damageBits & (1<<24) && random_num( 1 , iGrenade[ iAttacker ] ) == 1){
		fDamage = 9999.0
	}
}

public diablo_upgrade_item( id ){
	iGrenade[ id ] -= random_num(-1,1)
}

public diablo_copy_item( iFrom , iTo ){
	iGrenade[ iTo ]	=	iGrenade[ iFrom ];
	
	bItem[ iTo ]	=	true;
}

public grenade_throw( index,greindex,wId ){
	if( bItem [ index ] && wId	==	CSW_HEGRENADE && !task_exists( index ) ){
		set_task( 15.0 , "giveGrenade" , index , .flags = "b" );
	}
}

public giveGrenade( id ){
	if( !is_user_alive( id ) || !bItem [ id ] ){
		remove_task( id )
	}
	else{
		give_item( id , "weapon_hegrenade" );
	}
}
